﻿namespace Battleship.Drawings;

/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
internal class DrawingWarshipCompareByType : IComparer<DrawingWarship?>
{
    public int Compare(DrawingWarship? x, DrawingWarship? y)
    {
        if (x == null || x.EntityWarship == null)
        {
            return 1;
        }

        if (y == null || y.EntityWarship == null)
        {
            return -1;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityWarship.Speed.CompareTo(y.EntityWarship.Speed);

        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityWarship.Weight.CompareTo(y.EntityWarship.Weight);
    }
}
