﻿namespace Battleship.Drawings;

/// <summary>
/// Сравнение по цвету, скорости, весу
/// </summary>
public class DrawingWarshipComparerByColor : IComparer<DrawingWarship?>
{
    public int Compare(DrawingWarship? x, DrawingWarship? y)
    {
        // TODO прописать логику сравнения по цветам, скорости, весу
        if (x == null || x.EntityWarship == null)
        {
            return 1;
        }

        if (y == null || y.EntityWarship == null)
        {
            return -1;
        }

        if (x.EntityWarship.BodyColor != y.EntityWarship.BodyColor)
        {
            return x.EntityWarship.BodyColor.Name.CompareTo(y.EntityWarship.BodyColor.Name);
        }

        var speedCompare = x.EntityWarship.Speed.CompareTo(y.EntityWarship.Speed);

        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityWarship.Weight.CompareTo(y.EntityWarship.Weight);
    }
}
