﻿namespace Battleship.Drawings;

using Battleship.Entities;
using System.Diagnostics.CodeAnalysis;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawingWarshipEqutables : IEqualityComparer<DrawingWarship?>
{
    public bool Equals(DrawingWarship? x, DrawingWarship? y)
    {
        if (x == null || x.EntityWarship == null)
        {
            return false;
        }

        if (y == null || y.EntityWarship == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityWarship.Speed != y.EntityWarship.Speed)
        { 
            return false; 
        }

        if (x.EntityWarship.Weight != y.EntityWarship.Weight)
        {
            return false;
        }
        if (x.EntityWarship.BodyColor != y.EntityWarship.BodyColor)
        {
            return false;
        }

        if (x is DrawingBattleship && y is DrawingBattleship)
        {
            // TODO доделать логику сравнения дополнительных параметров
            EntityBattleship xBattleship = (EntityBattleship)x.EntityWarship;
            EntityBattleship yBattleship = (EntityBattleship)y.EntityWarship;

            if (xBattleship.AdditionalColor != yBattleship.AdditionalColor)
            {
                return false;
            }

            if (xBattleship.Compartment != yBattleship.Compartment)
            {
                return false;
            }

            if (xBattleship.Tower != yBattleship.Tower)
            {
                return false;
            }
        }

        return true;
    }

    public int GetHashCode([DisallowNull] DrawingWarship obj) 
    {
        return obj.GetHashCode();
    }
}
