﻿using Battleship.CollectionGenericObjects;
using System.Runtime.Serialization;

namespace Battleship.Exceptions;

/// <summary>
/// Класс, описывающий ошибку повторяющегося элемента в коллекции
/// </summary>
[Serializable]
internal class CollectionAlreadyExistsException : ApplicationException
{
    public CollectionAlreadyExistsException(CollectionInfo collectionInfo) : base("В коллекции уже есть такой элемент: " + collectionInfo) { }
    public CollectionAlreadyExistsException() : base("В коллекции уже есть такой элемент") { }
    public CollectionAlreadyExistsException(string message) : base(message) { }
    public CollectionAlreadyExistsException(string message, Exception exception) : base(message, exception) { }
    protected CollectionAlreadyExistsException(SerializationInfo info, StreamingContext context) : base(info, context) { }
}
