﻿using System.Runtime.Serialization;

namespace Battleship.Exceptions;

/// <summary>
/// Класс, описывающий ошибку, что позиция вышла за границы коллекции
/// </summary>
[Serializable]
internal class PositionOutOfCollectionException : ApplicationException
{
    public PositionOutOfCollectionException(int i) : base("Выход за границы коллекции. Позиция " + i) { }
    public PositionOutOfCollectionException() : base() { }
    public PositionOutOfCollectionException(string message) : base(message) { }
    public PositionOutOfCollectionException(string message, Exception exception) : base(message, exception) { }
    protected PositionOutOfCollectionException(SerializationInfo info, StreamingContext context) : base(info, context) { }
}